You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

274 lines
7.1 KiB

  1. #!/bin/bash
  2. set -eux
  3. ## 0k git remote path
  4. GIT_0K_BASE=${GIT_0K_BASE:-"0k-ro:/var/git"}
  5. ## 0k git remote options
  6. GIT_0K_CLONE_OPTIONS=${GIT_0K_CLONE_OPTIONS:-""}
  7. ##
  8. ## Install 0k-manage
  9. ##
  10. mkdir -p /opt/apps
  11. (
  12. if [ -d "/opt/apps/0k-manage" ]; then
  13. cd /opt/apps/0k-manage &&
  14. git pull -r
  15. else
  16. cd /opt/apps &&
  17. git clone $GIT_0K_CLONE_OPTIONS "$GIT_0K_BASE/0k/0k-manage.git" &&
  18. cd /opt/apps/0k-manage &&
  19. git checkout 0k/prod/master
  20. fi
  21. pip install sact.epoch || exit 1
  22. if [ "$(python -c 'import sact.epoch' 2>&1 | tail -n 1)" == "ImportError: No module named interface" ]; then
  23. echo "Error: conflicting installation of zope.interface detected. Trying workaround."
  24. (
  25. cd /usr/local/lib/python2.7/dist-packages
  26. mv zope zope-bad
  27. ) &&
  28. pip install zope.interface --upgrade &&
  29. pip install zope.component --upgrade
  30. if [ "$(python -c 'import sact.epoch' 2>&1 | tail -n 1)" == "" ]; then
  31. echo "Workaround worked."
  32. else
  33. echo "Failed work around."
  34. exit 1
  35. fi
  36. fi
  37. # ln -sf /opt/apps/0k-manage/src/bin/* /usr/local/bin/
  38. )
  39. ##
  40. ## Remove possible previous docker-compose related stuff
  41. ##
  42. if [ -f /etc/compose/local.conf ]; then
  43. sed -ri 's%^(. /opt/venv/docker-compose/bin/activate)$%# \1 ## docker-compsoe not needed anymore%g' \
  44. /etc/compose/local.conf
  45. fi
  46. ##
  47. ## Install 0k-charm
  48. ##
  49. (
  50. apt-get install -y kal-shlib-charm kal-shlib-cache kal-shlib-cmdline </dev/null
  51. if [ -d "/opt/apps/0k-charm" ]; then
  52. cd /opt/apps/0k-charm &&
  53. git checkout master &&
  54. git pull -r
  55. else
  56. cd /opt/apps &&
  57. git clone $GIT_0K_CLONE_OPTIONS "$GIT_0K_BASE/0k/0k-charm.git"
  58. fi
  59. ln -sfn /opt/apps/0k-charm/bin/charm /usr/local/sbin/charm
  60. )
  61. ##
  62. ## Install 0k-charms
  63. ##
  64. (
  65. if [ -d "/opt/apps/0k-charms" ]; then
  66. cd /opt/apps/0k-charms &&
  67. git checkout master &&
  68. git pull -r
  69. else
  70. cd /opt/apps &&
  71. git clone $GIT_0K_CLONE_OPTIONS "$GIT_0K_BASE/0k/0k-charms.git"
  72. fi
  73. if [ -d "/srv/charm-store" ]; then
  74. if [ -L "/srv/charm-store" ]; then
  75. info "Already have a valid /srv/charm-store"
  76. elif [ -L "/srv/charm-store/0k-charms" ]; then
  77. mv /srv/charm-store{,.old} &&
  78. mv /srv/charm-store.old/0k-charms /srv/charm-store &&
  79. rmdir /srv/charm-store.old
  80. else
  81. die "Unexpected layout of '/srv/charm-store'. Bailing out."
  82. fi
  83. else
  84. ln -sfn /opt/apps/0k-charms /srv/charm-store
  85. fi
  86. )
  87. ##
  88. ## Install lxc-scripts
  89. ##
  90. (
  91. if ! [ -d "/opt/apps/lxc-scripts" ]; then
  92. cd /opt/apps &&
  93. git clone $GIT_0K_CLONE_OPTIONS "$GIT_0K_BASE/0k/lxc-scripts.git"
  94. fi
  95. cd /opt/apps/lxc-scripts &&
  96. git checkout master &&
  97. git pull -r &&
  98. ln -sfn /opt/apps/lxc-scripts/bin/lxc-* /usr/local/sbin/ &&
  99. if [ -f /etc/default/lxc ]; then
  100. if [ -f /etc/default/lxc.pre-install ]; then
  101. cp /etc/default/lxc.pre-install /etc/default/lxc
  102. else
  103. cp /etc/default/lxc /etc/default/lxc.pre-install
  104. fi
  105. [ -d /usr/lib/lxc/templates ] && {
  106. ln -sfn /opt/apps/lxc-scripts/usr/lib/lxc/templates/lxc-0k-ubuntu-cloud /usr/lib/lxc/templates/
  107. echo TEMPLATE_PATH=/usr/lib/lxc/templates >> /etc/default/lxc
  108. }
  109. [ -d /usr/share/lxc/templates ] && {
  110. ln -sfn /opt/apps/lxc-scripts/usr/lib/lxc/templates/lxc-0k-ubuntu-cloud /usr/share/lxc/templates
  111. echo TEMPLATE_PATH=/usr/share/lxc/templates >> /etc/default/lxc
  112. }
  113. fi
  114. )
  115. ##
  116. ## Install 0k-docker
  117. ##
  118. (
  119. apt-get install -y kal-shlib-docker jq </dev/null
  120. if [ -d "/opt/apps/0k-docker" ]; then
  121. cd /opt/apps/0k-docker &&
  122. git checkout master &&
  123. git pull -r
  124. else
  125. cd /opt/apps &&
  126. git clone $GIT_0K_CLONE_OPTIONS "$GIT_0K_BASE/0k/0k-docker"
  127. fi
  128. ln -sfn /opt/apps/0k-docker/src/bin/* /usr/local/sbin/
  129. ## Probably dangerous for docker only solution that do not
  130. ## rely on the same choices
  131. #ln -sfn /opt/apps/0k-docker/src/bin/docker-clean /etc/cron.daily/docker-clean
  132. ## in update, will remove broken links to binaries that were removed
  133. find -L /usr/local/sbin -maxdepth 1 -type l -ilname /opt/apps/0k-docker/\* -delete
  134. )
  135. ##
  136. ## Install 0k.io certificate authority
  137. ##
  138. ## Note that docker should be installed after (or be restarted).
  139. apt-get install -y curl </dev/null
  140. ## This does not seem to work anymore (docker v1.12, ubutnu 14.04 on gani)
  141. ca=/etc/ssl/ca.0k.io.pem
  142. need_restart=
  143. oldmd5=
  144. if [ -f "$ca" ]; then
  145. oldmd5=$(md5sum "$ca")
  146. fi
  147. echo "Fetching 0k.io CA certificate..."
  148. curl http://docker.0k.io/get/ca.0k.io.pem > "$ca"
  149. if [[ "$(md5sum "$ca")" != "$oldmd5" ]]; then
  150. need_restart=1
  151. cat "$ca" >> /etc/ssl/certs/ca-certificates.crt
  152. fi
  153. ## This is the new way: https://docs.docker.com/engine/security/certificates/
  154. ca_ln="/etc/docker/certs.d/docker.0k.io/ca.crt"
  155. mkdir -p "$(dirname "$ca_ln")"
  156. if ! [ -L "$ca_ln" ] || [ "$(realpath "$ca_ln")" != "$ca" ] ; then
  157. ln -sfn "$ca" "$ca_ln"
  158. need_restart=1
  159. fi
  160. if [ "$need_restart" ]; then
  161. service docker restart
  162. fi
  163. echo "Login into our server."
  164. docker login -u vm -p iamavm https://docker.0k.io
  165. sed -ri 's/^#(net\.ipv4\.ip_forward=1)$/\1/g' /etc/sysctl.conf
  166. sysctl -w net.ipv4.ip_forward=1
  167. ##
  168. ## Installation of compose
  169. ##
  170. docker pull docker.0k.io/compose
  171. if [ -d "/opt/apps/0k-compose" ]; then
  172. cd "/opt/apps/0k-compose" &&
  173. git pull -r
  174. else
  175. mkdir -p /opt/apps && cd /opt/apps
  176. git clone "$GIT_0K_BASE"/0k/0k-compose.git
  177. fi
  178. [ -e /usr/local/bin/compose ] || ln -sfnv /opt/apps/0k-compose/bin/compose /usr/local/bin/
  179. rm -rf /var/cache/compose
  180. cat <<EOF > /etc/default/datastore
  181. DATASTORE=/srv/datastore
  182. SNAPSHOT_BACKUP=/var/backups/snapshot
  183. EOF
  184. cat <<EOF > /etc/default/compose
  185. ## if not provided, this will be the default service launched.
  186. export DEFAULT_SERVICES=""
  187. ## In new compose (running in docker) this is not yet really supported,
  188. ## and is it wanted ?
  189. #export DEFAULT_PROJECT_NAME=$(hostname | cut -f 2 -d . )
  190. #DEFAULT_PROJECT_NAME=\${DEFAULT_PROJECT_NAME,,} ## to lowercase
  191. export DOCKER_DATASTORE=\$([ -e /etc/default/datastore ] && . /etc/default/datastore && echo \$DATASTORE)
  192. export DATASTORE=\$DOCKER_DATASTORE/data
  193. export CONFIGSTORE=\$DOCKER_DATASTORE/config
  194. EOF
  195. if ! egrep "^DEFAULT_COMPOSE_FILE=/etc/compose/compose.yml$" /etc/compose/local.conf >/dev/null 2>&1; then
  196. mkdir /etc/compose -p
  197. touch /etc/compose/local.conf
  198. echo "DEFAULT_COMPOSE_FILE=/etc/compose/compose.yml" >> /etc/compose/local.conf
  199. fi
  200. ##
  201. ## Install pgm
  202. ##
  203. (
  204. if [ -d "/opt/apps/0k-pgm" ]; then
  205. cd /opt/apps/0k-pgm &&
  206. git pull -r
  207. else
  208. cd /opt/apps &&
  209. git clone $GIT_0K_CLONE_OPTIONS "$GIT_0K_BASE/0k/0k-pgm.git" &&
  210. cd /opt/apps/0k-pgm &&
  211. git checkout master
  212. fi
  213. ln -sfnv /opt/apps/0k-pgm/bin/* /usr/local/bin/
  214. find -L /usr/local/bin -maxdepth 1 -type l -ilname /opt/apps/0k-pgm/bin/\* -delete
  215. apt-get install -y --force-yes pv buffer < /dev/null
  216. apt-get install -y postgresql-client </dev/null
  217. )